{*************************************************************}
{            Icon Grabber Component for Delphi 16/32          }
{ Version:   1.0                                              }
{ Author:    Aleksey Kuznetsov, Kiev, Ukraine                 }
{              (Xacker), ,          }
{ E-Mail:    xacker@phreaker.net                              }
{ Home Page: http://www.angen.net/~xacker/                    }
{ Created:   April, 19, 1999                                  }
{ Modified:  April, 19, 1999                                  }
{ Legal:     Copyright (c) 1999 by Aleksey Xacker             }
{*************************************************************}
{                     IMPORTANT NOTE:                         }
{ This software is provided 'as-is', without any express or   }
{ implied warranty. In no event will the author be held       }
{ liable for any damages arising from the use of this         }
{ software.                                                   }
{ Permission is granted to anyone to use this software for    }
{ any purpose, including commercial applications, and to      }
{ alter it and redistribute it freely, subject to the         }
{ following restrictions:                                     }
{ 1. The origin of this software must not be misrepresented,  }
{    you must not claim that you wrote the original software. }
{    If you use this software in a product, an acknowledgment }
{    in the product documentation would be appreciated but is }
{    not required.                                            }
{ 2. Altered source versions must be plainly marked as such,  }
{    and must not be misrepresented as being the original     }
{    software.                                                }
{ 3. This notice may not be removed or altered from any       }
{    source distribution.                                     }
{*************************************************************}

unit IcoGrab;

interface

uses
  {$IFDEF Win32}Windows, {$ELSE} WinTypes, WinProcs, {$ENDIF}
  Messages, Classes, Graphics, Controls, SysUtils, ShellAPI;

type
  TIconGrabber = class(TCustomControl)
  private
    FIcon: TIcon;
    FFileName: String;
    FIconIndex: Integer;

    procedure SetIcon(Value: TIcon);
    procedure SetFileName(Value: String);
    procedure SetIconIndex(Value: Integer);
  protected
  public
    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;
    procedure Paint; override;

    procedure Grab(aFileName: String; aIconIndex: Integer);
  published
    property Icon: TIcon read FIcon write SetIcon;
    property FileName: String read FFileName write SetFileName;
    property IconIndex: Integer read FIconIndex write SetIconIndex;
    property Visible;
  end;

procedure Register;

implementation

constructor TIconGrabber.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  FIcon := TIcon.Create;
  Width := 32;
  Height := 32;
end;

destructor TIconGrabber.Destroy;
begin
  FIcon.Destroy;
  inherited Destroy;
end;

procedure TIconGrabber.Paint;
begin
  inherited Paint;
  with Canvas do Draw(0, 0, FIcon);
end;

procedure TIconGrabber.SetIcon(Value: TIcon);
begin
  FIcon.Assign(Value);
  Invalidate;
end;

procedure TIconGrabber.SetFileName(Value: String);
begin
  if FFileName <> Value then
   begin
    FFileName := Value;
    Grab(FFileName, FIconIndex);
   end;
end;

procedure TIconGrabber.SetIconIndex(Value: Integer);
begin
  if FIconIndex <> Value then
   begin
    FIconIndex := Value;
    Grab(FFileName, FIconIndex);
   end;
end;

procedure TIconGrabber.Grab(aFileName: String; aIconIndex: Integer);
var
  PC: Array[0..$FF] of Char;
begin
  FFileName := aFileName;
  FIconIndex := aIconIndex;
  StrPCopy(PC, aFileName);

  FIcon.Handle := ExtractIcon(0, PC, aIconIndex);
  Invalidate;
end;

procedure Register;
begin
  RegisterComponents('Xacker', [TIconGrabber]);
end;

end.
